无重复字符的最长子串(Longest Substring Without Repeating Characters)

问题:

LeetCode-3

English:

Given a string, find the length of the longest substring without repeating characters.

Example 1:

Input: "abcabcbb"
Output: 3
Explanation: The answer is "abc", with the length of 3.

Example 2:

Input: "bbbbb"
Output: 1
Explanation: The answer is "b", with the length of 1.

Example 3:

Input: "pwwkew"
Output: 3
Explanation: The answer is "wke", with the length of 3.

Note that the answer must be a substring, "pwke" is a subsequence and not a substring

中文:

给定一个字符串,请你找出其中不含有重复字符的 最长子串 的长度。

示例 1:

输入: "abcabcbb"
输出: 3
解释: 因为无重复字符的最长子串是 "abc",所以其长度为 3。

示例 2:

输入: "bbbbb"
输出: 1
解释: 因为无重复字符的最长子串是 "b",所以其长度为 1。

示例 3:

输入: "pwwkew"
输出: 3
解释: 因为无重复字符的最长子串是 "wke",所以其长度为 3。

请注意,你的答案必须是 子串 的长度,"pwke" 是一个子序列,不是子串

解法:

通过使用HashMap来记录字符串中的字母和字母的位置,并使用头尾来控制字符串长度,每次碰到新字母长度就加一,如果头部碰到旧字母,则将尾进一,头进一,并统计新子序列的长度,并找出最大的子序列

代码实现(java版)

        if (s == null || s.length() == 0)
            return 0;
        HashMap map = new HashMap();
        int length = 0;
        int tail =0;
        for (int i = 0; i < s.length(); i++) {
            if (map.containsKey(s.charAt(i))) {
                /*
                 * 发生重复,则将tail进行前移 如果下一位是新的字母,则将其位置赋值给tail
                 *  如果是老字母,说明此长度已经计数,则tail保持
                 */
                tail = Math.max(tail, map.get(s.charAt(i)) + 1);
            }
            /*
             * 字母进哈希表, 如果是新字母,则开辟新空间存储起来 
             * 如果是老字母,则将新位置赋值给老字母,以便计算新长度
             */
            map.put(s.charAt(i), i);
            /*
             * 记录下每次比较的长度,并从中找出最大值
             */
            length = Math.max(length, i - tail + 1);
        }
        return length;

你可能感兴趣的:(无重复字符的最长子串(Longest Substring Without Repeating Characters))